import greenfoot.*;
import java.util.List;
public class Grass extends Solid
{
    public void act()
    {
        CheckForPress();
        int RandomNum=Greenfoot.getRandomNumber(99);
        Actor Dirt = getOneObjectAtOffset(0, -16, Dirt.class), Grass = getOneObjectAtOffset(0, -16, Grass.class), Stone = getOneObjectAtOffset(0, -16, Stone.class), Bedrock = getOneObjectAtOffset(0, -16, Bedrock.class), LiquoriceLog = getOneObjectAtOffset(0, -16, LiquoriceLog.class), DiamondOre = getOneObjectAtOffset(0, -16, DiamondOre.class), CopperOre = getOneObjectAtOffset(0, -16, CopperOre.class), CoalOre = getOneObjectAtOffset(0, -16, CoalOre.class), Cobblestone = getOneObjectAtOffset(0, -16, Cobblestone.class);
        
        if(RandomNum!=0&&(Dirt == null || Grass == null || Stone == null || Bedrock == null || LiquoriceLog == null || DiamondOre == null || CopperOre == null || CoalOre == null || Cobblestone == null)){
            Break(new DirtDrop(), 1);
        }
        
        if(RandomNum==0)
        {
            if(DirtDL() && !DirtL() && !GrassL() && !StoneL() && !BedrockL() && !LightLeavesL() && !LiquoriceLogL() && !DiamondOreL() && !CopperOreL() && !CoalOreL() && !CobblestoneL()){
                Actor actor = getOneObjectAtOffset(-16, 16, Dirt.class);
                getWorld().addObject(new Grass(), actor.getX(), actor.getY());
                getWorld().removeObject(actor);
            }
            if(DirtL() && !DirtUL() && !GrassUL() && !StoneUL() && !BedrockUL() && !LightLeavesUL() && !LiquoriceLogUL() && !DiamondOreUL() && !CopperOreUL() && !CoalOreUL() && !CobblestoneUL()){
                Actor actor = getOneObjectAtOffset(-16, 0, Dirt.class);
                getWorld().addObject(new Grass(), actor.getX(), actor.getY());
                getWorld().removeObject(actor);
            }
            if(DirtUL() && !DirtUUL() && !GrassUUL() && !StoneUUL() && !BedrockUUL() && !LightLeavesUUL() && !LiquoriceLogUUL() && !DiamondOreUUL() && !CopperOreUUL() && !CoalOreUUL() && !CobblestoneUUL()){
                Actor actor = getOneObjectAtOffset(-16, -16, Dirt.class);
                getWorld().addObject(new Grass(), actor.getX(), actor.getY());
                getWorld().removeObject(actor);
            }
            if(DirtDR() && !DirtR() && !GrassR() && !StoneR() && !BedrockR() && !LightLeavesR() && !LiquoriceLogR() && !DiamondOreR() && !CopperOreR() && !CoalOreR() && !CobblestoneR()){
                Actor actor = getOneObjectAtOffset(16, 16, Dirt.class);
                getWorld().addObject(new Grass(), actor.getX(), actor.getY());
                getWorld().removeObject(actor);
            }
            if(DirtR() && !DirtUR() && !GrassUR() && !StoneUR() && !BedrockUR() && !LightLeavesUR() && !LiquoriceLogUR() && !DiamondOreUR() && !CopperOreUR() && !CoalOreUR() && !CobblestoneUR()){
                Actor actor = getOneObjectAtOffset(16, 0, Dirt.class);
                getWorld().addObject(new Grass(), actor.getX(), actor.getY());
                getWorld().removeObject(actor);
            }
            if(DirtUR() && !DirtUUR() && !GrassUUR() && !StoneUUR() && !BedrockUUR() && !LightLeavesUUR() && !LiquoriceLogUUR() && !DiamondOreUUR() && !CopperOreUUR() && !CoalOreUUR() && !CobblestoneUUR()){
                Actor actor = getOneObjectAtOffset(16, -16, Dirt.class);
                getWorld().addObject(new Grass(), actor.getX(), actor.getY());
                getWorld().removeObject(actor);
            }
            if(Dirt != null || Grass != null || Stone != null || Bedrock != null || LiquoriceLog != null || DiamondOre != null || CopperOre != null || CoalOre != null || Cobblestone != null){
                getWorld().addObject(new Dirt(), getX(), getY());
                getWorld().removeObject(this);
            }
        }
    }
    
    public boolean DirtDR()
    {
        Actor actor = getOneObjectAtOffset(16, 16, Dirt.class);
        return actor !=null;
    }
    
    public boolean DirtR()
    {
        Actor actor = getOneObjectAtOffset(16, 0, Dirt.class);
        return actor !=null;
    }
    
    public boolean DirtUR()
    {
        Actor actor = getOneObjectAtOffset(16, -16, Dirt.class);
        return actor !=null;
    }
    
    public boolean DirtUUR()
    {
        Actor actor = getOneObjectAtOffset(16, -32, Dirt.class);
        return actor !=null;
    }
    
    public boolean DirtDL()
    {
        Actor actor = getOneObjectAtOffset(-16, 16, Dirt.class);
        return actor !=null;
    }
    
    public boolean DirtL()
    {
        Actor actor = getOneObjectAtOffset(-16, 0, Dirt.class);
        return actor !=null;
    }
    
    public boolean DirtUL()
    {
        Actor actor = getOneObjectAtOffset(-16, -16, Dirt.class);
        return actor !=null;
    }
    
    public boolean DirtUUL()
    {
        Actor actor = getOneObjectAtOffset(-16, -32, Dirt.class);
        return actor !=null;
    }
    
    public boolean GrassR()
    {
        Actor actor = getOneObjectAtOffset(16, 0, Grass.class);
        return actor !=null;
    }
    
    public boolean GrassUR()
    {
        Actor actor = getOneObjectAtOffset(16, -16, Grass.class);
        return actor !=null;
    }
    
    public boolean GrassUUR()
    {
        Actor actor = getOneObjectAtOffset(16, -32, Grass.class);
        return actor !=null;
    }
    
    public boolean GrassL()
    {
        Actor actor = getOneObjectAtOffset(-16, 0, Grass.class);
        return actor !=null;
    }
    
    public boolean GrassUL()
    {
        Actor actor = getOneObjectAtOffset(-16, -16, Grass.class);
        return actor !=null;
    }
    
    public boolean GrassUUL()
    {
        Actor actor = getOneObjectAtOffset(-16, -32, Grass.class);
        return actor !=null;
    }
    
    public boolean StoneR()
    {
        Actor actor = getOneObjectAtOffset(16, 0, Stone.class);
        return actor !=null;
    }
    
    public boolean StoneUR()
    {
        Actor actor = getOneObjectAtOffset(16, -16, Stone.class);
        return actor !=null;
    }
    
    public boolean StoneUUR()
    {
        Actor actor = getOneObjectAtOffset(16, -32, Stone.class);
        return actor !=null;
    }
    
    public boolean StoneL()
    {
        Actor actor = getOneObjectAtOffset(-16, 0, Stone.class);
        return actor !=null;
    }
    
    public boolean StoneUL()
    {
        Actor actor = getOneObjectAtOffset(-16, -16, Stone.class);
        return actor !=null;
    }
    
    public boolean StoneUUL()
    {
        Actor actor = getOneObjectAtOffset(-16, -32, Stone.class);
        return actor !=null;
    }
    
    public boolean BedrockR()
    {
        Actor actor = getOneObjectAtOffset(16, 0, Bedrock.class);
        return actor !=null;
    }
    
    public boolean BedrockUR()
    {
        Actor actor = getOneObjectAtOffset(16, -16, Bedrock.class);
        return actor !=null;
    }
    
    public boolean BedrockUUR()
    {
        Actor actor = getOneObjectAtOffset(16, -32, Bedrock.class);
        return actor !=null;
    }
    
    public boolean BedrockL()
    {
        Actor actor = getOneObjectAtOffset(-16, 0, Bedrock.class);
        return actor !=null;
    }
    
    public boolean BedrockUL()
    {
        Actor actor = getOneObjectAtOffset(-16, -16, Bedrock.class);
        return actor !=null;
    }
    
    public boolean BedrockUUL()
    {
        Actor actor = getOneObjectAtOffset(-16, -32, Bedrock.class);
        return actor !=null;
    }
    
    public boolean LightLeavesR()
    {
        Actor actor = getOneObjectAtOffset(16, 0, LightLeaves.class);
        return actor !=null;
    }
    
    public boolean LightLeavesUR()
    {
        Actor actor = getOneObjectAtOffset(16, -16, LightLeaves.class);
        return actor !=null;
    }
    
    public boolean LightLeavesUUR()
    {
        Actor actor = getOneObjectAtOffset(16, -32, LightLeaves.class);
        return actor !=null;
    }
    
    public boolean LightLeavesL()
    {
        Actor actor = getOneObjectAtOffset(-16, 0, LightLeaves.class);
        return actor !=null;
    }
    
    public boolean LightLeavesUL()
    {
        Actor actor = getOneObjectAtOffset(-16, -16, LightLeaves.class);
        return actor !=null;
    }
    
    public boolean LightLeavesUUL()
    {
        Actor actor = getOneObjectAtOffset(-16, -32, LightLeaves.class);
        return actor !=null;
    }
    
    public boolean LiquoriceLogR()
    {
        Actor actor = getOneObjectAtOffset(16, 0, LiquoriceLog.class);
        return actor !=null;
    }
    
    public boolean LiquoriceLogUR()
    {
        Actor actor = getOneObjectAtOffset(16, -16, LiquoriceLog.class);
        return actor !=null;
    }
    
    public boolean LiquoriceLogUUR()
    {
        Actor actor = getOneObjectAtOffset(16, -32, LiquoriceLog.class);
        return actor !=null;
    }
    
    public boolean LiquoriceLogL()
    {
        Actor actor = getOneObjectAtOffset(-16, 0, LiquoriceLog.class);
        return actor !=null;
    }
    
    public boolean LiquoriceLogUL()
    {
        Actor actor = getOneObjectAtOffset(-16, -16, LiquoriceLog.class);
        return actor !=null;
    }
    
    public boolean LiquoriceLogUUL()
    {
        Actor actor = getOneObjectAtOffset(-16, -32, LiquoriceLog.class);
        return actor !=null;
    }
    
    public boolean DiamondOreR()
    {
        Actor actor = getOneObjectAtOffset(16, 0, DiamondOre.class);
        return actor !=null;
    }
    
    public boolean DiamondOreUR()
    {
        Actor actor = getOneObjectAtOffset(16, -16, DiamondOre.class);
        return actor !=null;
    }
    
    public boolean DiamondOreUUR()
    {
        Actor actor = getOneObjectAtOffset(16, -32, DiamondOre.class);
        return actor !=null;
    }
    
    public boolean DiamondOreL()
    {
        Actor actor = getOneObjectAtOffset(-16, 0, DiamondOre.class);
        return actor !=null;
    }
    
    public boolean DiamondOreUL()
    {
        Actor actor = getOneObjectAtOffset(-16, -16, DiamondOre.class);
        return actor !=null;
    }
    
    public boolean DiamondOreUUL()
    {
        Actor actor = getOneObjectAtOffset(-16, -32, DiamondOre.class);
        return actor !=null;
    }
    
    public boolean CopperOreR()
    {
        Actor actor = getOneObjectAtOffset(16, 0, CopperOre.class);
        return actor !=null;
    }
    
    public boolean CopperOreUR()
    {
        Actor actor = getOneObjectAtOffset(16, -16, CopperOre.class);
        return actor !=null;
    }
    
    public boolean CopperOreUUR()
    {
        Actor actor = getOneObjectAtOffset(16, -32, CopperOre.class);
        return actor !=null;
    }
    
    public boolean CopperOreL()
    {
        Actor actor = getOneObjectAtOffset(-16, 0, CopperOre.class);
        return actor !=null;
    }
    
    public boolean CopperOreUL()
    {
        Actor actor = getOneObjectAtOffset(-16, -16, CopperOre.class);
        return actor !=null;
    }
    
    public boolean CopperOreUUL()
    {
        Actor actor = getOneObjectAtOffset(-16, -32, CopperOre.class);
        return actor !=null;
    }
    
    public boolean CoalOreR()
    {
        Actor actor = getOneObjectAtOffset(16, 0, CoalOre.class);
        return actor !=null;
    }
    
    public boolean CoalOreUR()
    {
        Actor actor = getOneObjectAtOffset(16, -16, CoalOre.class);
        return actor !=null;
    }
    
    public boolean CoalOreUUR()
    {
        Actor actor = getOneObjectAtOffset(16, -32, CoalOre.class);
        return actor !=null;
    }
    
    public boolean CoalOreL()
    {
        Actor actor = getOneObjectAtOffset(-16, 0, CoalOre.class);
        return actor !=null;
    }
    
    public boolean CoalOreUL()
    {
        Actor actor = getOneObjectAtOffset(-16, -16, CoalOre.class);
        return actor !=null;
    }
    
    public boolean CoalOreUUL()
    {
        Actor actor = getOneObjectAtOffset(-16, -32, CoalOre.class);
        return actor !=null;
    }
    
    public boolean CobblestoneR()
    {
        Actor actor = getOneObjectAtOffset(16, 0, Cobblestone.class);
        return actor !=null;
    }
    
    public boolean CobblestoneUR()
    {
        Actor actor = getOneObjectAtOffset(16, -16, Cobblestone.class);
        return actor !=null;
    }
    
    public boolean CobblestoneUUR()
    {
        Actor actor = getOneObjectAtOffset(16, -32, Cobblestone.class);
        return actor !=null;
    }
    
    public boolean CobblestoneL()
    {
        Actor actor = getOneObjectAtOffset(-16, 0, Cobblestone.class);
        return actor !=null;
    }
    
    public boolean CobblestoneUL()
    {
        Actor actor = getOneObjectAtOffset(-16, -16, Cobblestone.class);
        return actor !=null;
    }
    
    public boolean CobblestoneUUL()
    {
        Actor actor = getOneObjectAtOffset(-16, -32, Cobblestone.class);
        return actor !=null;
    }
}
