import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;
import java.util.List;
/**
 * Write a description of class GridCursor here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class GridCursor extends Actor
{
    int X;
    int Y;
    GreenfootImage img;
    public GridCursor()
    {
        img = new GreenfootImage(16, 16);
        setImage(img);
    }
    
    public void act()
    {
        Gridlock();
        List<PlayerArm> actors = getObjectsInRange(16*3, PlayerArm.class);
        boolean inRange = false;
        for(Actor a : actors){
            inRange = true;
            img.clear();
            img.setColor(new Color(0, 255, 0, 127));
            img.fill();
            setImage(img);
        }
        if(inRange == false){
            img.clear();
            img.setColor(new Color(255, 0, 0, 127));
            img.fill();
            setImage(img);
        }
        Actor grass = getOneObjectAtOffset(0, 16, Grass.class), dirt = getOneObjectAtOffset(0, 16, Dirt.class), stone = getOneObjectAtOffset(0, 16, Stone.class), bedrock = getOneObjectAtOffset(0, 16, Bedrock.class), lightLeaves = getOneObjectAtOffset(0, 16, LightLeaves.class), liquoriceLog = getOneObjectAtOffset(0, 16, LiquoriceLog.class), diamondOre = getOneObjectAtOffset(0, 16, DiamondOre.class), copperOre = getOneObjectAtOffset(0, 16, CopperOre.class), coalOre = getOneObjectAtOffset(0, 16, CoalOre.class), cobblestone = getOneObjectAtOffset(0, 16, Cobblestone.class), candySapling = getOneObjectAtOffset(0, 16, CandySapling.class);
        Actor grass2 = getOneObjectAtOffset(0, -16, Grass.class), dirt2 = getOneObjectAtOffset(0, -16, Dirt.class), stone2 = getOneObjectAtOffset(0, -16, Stone.class), bedrock2 = getOneObjectAtOffset(0, -16, Bedrock.class), lightLeaves2 = getOneObjectAtOffset(0, -16, LightLeaves.class), liquoriceLog2 = getOneObjectAtOffset(0, -16, LiquoriceLog.class), diamondOre2 = getOneObjectAtOffset(0, -16, DiamondOre.class), copperOre2 = getOneObjectAtOffset(0, -16, CopperOre.class), coalOre2 = getOneObjectAtOffset(0, -16, CoalOre.class), cobblestone2 = getOneObjectAtOffset(0, -16, Cobblestone.class), candySapling2 = getOneObjectAtOffset(0, -16, CandySapling.class);
        Actor grass3 = getOneObjectAtOffset(-16, 0, Grass.class), dirt3 = getOneObjectAtOffset(-16, 0, Dirt.class), stone3 = getOneObjectAtOffset(-16, 0, Stone.class), bedrock3 = getOneObjectAtOffset(-16, 0, Bedrock.class), lightLeaves3 = getOneObjectAtOffset(-16, 0, LightLeaves.class), liquoriceLog3 = getOneObjectAtOffset(-16, 0, LiquoriceLog.class), diamondOre3 = getOneObjectAtOffset(-16, 0, DiamondOre.class), copperOre3 = getOneObjectAtOffset(-16, 0, CopperOre.class), coalOre3 = getOneObjectAtOffset(-16, 0, CoalOre.class), cobblestone3 = getOneObjectAtOffset(-16, 0, Cobblestone.class), candySapling3 = getOneObjectAtOffset(-16, 0, CandySapling.class);
        Actor grass4 = getOneObjectAtOffset(16, 0, Grass.class), dirt4 = getOneObjectAtOffset(16, 0, Dirt.class), stone4 = getOneObjectAtOffset(16, 0, Stone.class), bedrock4 = getOneObjectAtOffset(16, 0, Bedrock.class), lightLeaves4 = getOneObjectAtOffset(16, 0, LightLeaves.class), liquoriceLog4 = getOneObjectAtOffset(16, 0, LiquoriceLog.class), diamondOre4 = getOneObjectAtOffset(16, 0, DiamondOre.class), copperOre4 = getOneObjectAtOffset(16, 0, CopperOre.class), coalOre4 = getOneObjectAtOffset(16, 0, CoalOre.class), cobblestone4 = getOneObjectAtOffset(16, 0, Cobblestone.class), candySapling4 = getOneObjectAtOffset(16, 0, CandySapling.class);
        Actor grass5 = getOneObjectAtOffset(0, 0, Grass.class), dirt5 = getOneObjectAtOffset(0, 0, Dirt.class), stone5 = getOneObjectAtOffset(0, 0, Stone.class), bedrock5 = getOneObjectAtOffset(0, 0, Bedrock.class), lightLeaves5 = getOneObjectAtOffset(0, 0, LightLeaves.class), liquoriceLog5 = getOneObjectAtOffset(0, 0, LiquoriceLog.class), diamondOre5 = getOneObjectAtOffset(0, 0, DiamondOre.class), copperOre5 = getOneObjectAtOffset(0, 0, CopperOre.class), coalOre5 = getOneObjectAtOffset(0, 0, CoalOre.class), cobblestone5 = getOneObjectAtOffset(0, 0, Cobblestone.class), candySapling5 = getOneObjectAtOffset(0, 0, CandySapling.class);
        MouseInfo mouse = Greenfoot.getMouseInfo();
        if(mouse!=null && mouse.getButton()==3 && Greenfoot.mouseClicked(this) && grass5==null && dirt5==null && stone5==null && bedrock5==null && lightLeaves5==null && liquoriceLog5==null && coalOre5==null && copperOre5==null && diamondOre5==null && cobblestone5==null && candySapling5==null && (grass!=null || dirt!=null || stone!=null || bedrock!=null || lightLeaves!=null || liquoriceLog!=null || diamondOre!=null || copperOre!=null || coalOre!=null || cobblestone!=null || candySapling!=null || grass2!=null || dirt2!=null || stone2!=null || bedrock2!=null || lightLeaves2!=null || liquoriceLog2!=null || diamondOre2!=null || copperOre2!=null || coalOre2!=null || cobblestone2!=null || candySapling2!=null || grass3!=null || dirt3!=null || stone3!=null || bedrock3!=null || lightLeaves3!=null || liquoriceLog3!=null || diamondOre3!=null || copperOre3!=null || coalOre3!=null || cobblestone3!=null || candySapling3!=null || grass4!=null || dirt4!=null || stone4!=null || bedrock4!=null || lightLeaves4!=null || liquoriceLog4!=null || diamondOre4!=null || copperOre4!=null || coalOre4!=null || cobblestone4!=null || candySapling4!=null))
        {
            GameWorld world = (GameWorld)getWorld();
            if(world.selector.getObject().equals("Dirt")){
                world.addObject(new Dirt(), getX(), getY());
            }else if(world.selector.getObject().equals("LiquoriceLogSide")){
                world.addObject(new LiquoriceLog(), getX(), getY());
            }else if(world.selector.getObject().equals("Cobblestone")){
                world.addObject(new Cobblestone(), getX(), getY());
            }else if(world.selector.getObject().equals("CandySapling")){
                world.addObject(new CandySapling(), getX(), getY());
            }
            if(!world.selector.getObject().equals("nothing")){
                if(world.selector.pos==1){
                    if(world.bar.s1.amount>1){
                        world.bar.s1.amount--;
                    }else{
                        world.removeObject(world.bar.s1);
                        world.bar.s1=null;
                    }
                }else if(world.selector.pos==2){
                    if(world.bar.s2.amount>1){
                        world.bar.s2.amount--;
                    }else{
                        world.removeObject(world.bar.s2);
                        world.bar.s2=null;
                    }
                }else if(world.selector.pos==3){
                    if(world.bar.s3.amount>1){
                        world.bar.s3.amount--;
                    }else{
                        world.removeObject(world.bar.s3);
                        world.bar.s3=null;
                    }
                }else if(world.selector.pos==4){
                    if(world.bar.s4.amount>1){
                        world.bar.s4.amount--;
                    }else{
                        world.removeObject(world.bar.s4);
                        world.bar.s4=null;
                    }
                }else if(world.selector.pos==5){
                    if(world.bar.s5.amount>1){
                        world.bar.s5.amount--;
                    }else{
                        world.removeObject(world.bar.s5);
                        world.bar.s5=null;
                    }
                }else if(world.selector.pos==6){
                    if(world.bar.s6.amount>1){
                        world.bar.s6.amount--;
                    }else{
                        world.removeObject(world.bar.s6);
                        world.bar.s6=null;
                    }
                }else if(world.selector.pos==7){
                    if(world.bar.s7.amount>1){
                        world.bar.s7.amount--;
                    }else{
                        world.removeObject(world.bar.s7);
                        world.bar.s7=null;
                    }
                }else if(world.selector.pos==8){
                    if(world.bar.s8.amount>1){
                        world.bar.s8.amount--;
                    }else{
                        world.removeObject(world.bar.s8);
                        world.bar.s8=null;
                    }
                }else if(world.selector.pos==9){
                    if(world.bar.s9.amount>1){
                        world.bar.s9.amount--;
                    }else{
                        world.removeObject(world.bar.s9);
                        world.bar.s9=null;
                    }
                }
            }
        }
    }
    
    public void Gridlock()
    {
        MouseInfo mouse = Greenfoot.getMouseInfo();
        if (mouse != null) {  
            X=mouse.getX()/16;
            Y=mouse.getY()/16;
            setLocation(X*16+8, Y*16+8);
        }
    }
}