import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;
/**
 * Write a description of class PlayerBody here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class PlayerBody extends Actor
{
    int vSpeed = 0;
    boolean left = true;
    
    public PlayerBody()
    {
    }
    
    public void act()
    {
        movement();
        fall();
        pickupItem();
    }
    
    /**
     * Left, Right, Jump
     */
    public void movement()
    {
        /**
         * Left, Right
         */
        int s = 2;
        if(Greenfoot.isKeyDown("control"))
            s = 4;
        if(Greenfoot.isKeyDown("a") && !canSee(-3, 7, Solid.class) && !canSee(-3, -7, Solid.class)){
            move(-s);
        }else if(Greenfoot.isKeyDown("d") && !canSee(3, 7, Solid.class) && !canSee(3, -7, Solid.class)){
            move(s);
        }
        /**
         * Jump
         */
        if((Greenfoot.isKeyDown("w") || Greenfoot.isKeyDown("space")) && !canSee(0, -getImage().getHeight()/2-1, Solid.class) && canSee(0, getImage().getHeight()/2, Solid.class))
        {
            setLocation(getX(), getY()-2);
            vSpeed = -10;
        }
    }
    
    public void fall()
    {
        if(canSee(0, getImage().getHeight()/2, Solid.class)){
            vSpeed = 0;
        }else if(canSee(0, -getImage().getHeight()/2, Solid.class)){
            if(vSpeed<=0)
                setLocation(getX(), getY()-vSpeed+1);
            else
                setLocation(getX(), getY()+vSpeed);
        }else{
            if(vSpeed <= 4)
                vSpeed+=2;
            else if(vSpeed==6)
                vSpeed+=6;
            setLocation(getX(), getY()+vSpeed);
        }
        if(canSee(0, getImage().getHeight()/2-1, Solid.class)){
            setLocation(getX(), getY()-2);
        }
    }
    
    public void lookLeft()
    {
        if(left == false){
            getImage().mirrorHorizontally();
            left = true;
        }
    }
    
    public void lookRight()
    {
        if(left == true){
            getImage().mirrorHorizontally();
            left = false;
        }
    }
    
    public void pickupItem()
    {
        GameWorld world = (GameWorld)getWorld();
        if(world.bar.s9==null || (world.bar.s9!=null&&world.bar.s9.amount<64))
        {
            Actor dirt = getOneIntersectingObject(DirtDrop.class), coal = getOneIntersectingObject(CoalDrop.class), copper = getOneIntersectingObject(CopperDrop.class), diamond = getOneIntersectingObject(DiamondDrop.class), liquoriceLog = getOneIntersectingObject(LiquoriceLogDrop.class), cobblestone = getOneIntersectingObject(CobblestoneDrop.class), candySapling = getOneIntersectingObject(CandySaplingDrop.class);
            if(dirt!=null){
                world.bar.addItem("Dirt");
                world.removeObject(dirt);
            }else if(coal!=null){
                world.bar.addItem("Coal");
                world.removeObject(coal);
            }else if(copper!=null){
                world.bar.addItem("Copper");
                world.removeObject(copper);
            }else if(diamond!=null){
                world.bar.addItem("Diamond");
                world.removeObject(diamond);
            }else if(liquoriceLog!=null){
                world.bar.addItem("LiquoriceLogSide");
                world.removeObject(liquoriceLog);
            }else if(cobblestone!=null){
                world.bar.addItem("Cobblestone");
                world.removeObject(cobblestone);
            }else if(candySapling!=null){
                world.bar.addItem("CandySapling");
                world.removeObject(candySapling);
            }
        }
    }
    
    public boolean canSee(int dx, int dy, Class clss)
    {
        Actor actor = getOneObjectAtOffset(dx, dy, clss);
        return actor !=null;
    }
}
